xref: /haiku/configure (revision 138f5fb42a1dc207571b975e3a62f397c75518d5)
152a38012Sejakowatz#!/bin/sh
252a38012Sejakowatz#
3338b8dc3SIngo Weinhold# configure [ <options> ]
4614026d7Sshatty
5022fa244SIngo Weinhold# usage
6022fa244SIngo Weinhold#
7022fa244SIngo Weinhold# Prints usage.
8022fa244SIngo Weinhold#
9022fa244SIngo Weinholdusage()
10022fa244SIngo Weinhold{
11022fa244SIngo Weinhold	cat << EOF
12022fa244SIngo Weinhold
13022fa244SIngo WeinholdUsage: $0 <options>
14022fa244SIngo Weinholdoptions:
1560d8d8fcSIngo Weinhold  --alternative-gcc-output-dir <dir>
1660d8d8fcSIngo Weinhold                              Build a Haiku installation that supports running
1760d8d8fcSIngo Weinhold                              executables built with a gcc version incompatible
1860d8d8fcSIngo Weinhold                              with the primary gcc (e.g. gcc 2 executables under
1960d8d8fcSIngo Weinhold                              a gcc 4 Haiku or vice versa). <dir> specifies the
2060d8d8fcSIngo Weinhold                              output directory of the other gcc. The directory
2160d8d8fcSIngo Weinhold                              must already be fully configured.
2260d8d8fcSIngo Weinhold                              Note, that a sub-jam will be executed when
2360d8d8fcSIngo Weinhold                              building Haiku. When using a jam that is not
2460d8d8fcSIngo Weinhold                              simply invoked by "jam", the JAM build variable
2560d8d8fcSIngo Weinhold                              needs to be set accordingly.
2660d8d8fcSIngo Weinhold                              To disable building the alternative libraries
2760d8d8fcSIngo Weinhold                              the variable HAIKU_ADD_ALTERNATIVE_GCC_LIBS can be
2860d8d8fcSIngo Weinhold                              unset in the UserBuildConfig file.
29338b8dc3SIngo Weinhold  --build-cross-tools <build tools dir>
30338b8dc3SIngo Weinhold                              Assume cross compilation. <build tools dir>
31338b8dc3SIngo Weinhold                              defines the location of the build tools sources.
32338b8dc3SIngo Weinhold                              They will be compiled and placed in the output
33a5b60fa8SOliver Tappe                              directory under "cross-tools". The HAIKU_* tools
34a5b60fa8SOliver Tappe                              variables will be set accordingly.
3520ab75e6SIngo Weinhold  --build-cross-tools-gcc4 <arch> <build tools dir>
3629ef597dSIngo Weinhold                              Like "--build-cross-tools" just that gcc 4 will
37a5b60fa8SOliver Tappe                              be used for cross-compilation. Note, that the
38a5b60fa8SOliver Tappe                              resulting Haiku installation built with gcc 4
39a5b60fa8SOliver Tappe                              will not be binary compatible with BeOS R5.
4020ab75e6SIngo Weinhold                              <arch> specifies the target architecture, either
41161ad355SJérôme Duval                              "x86", "ppc", "m68k", "arm" or "mipsel".
42eccc7665SIngo Weinhold  --cross-tools-prefix <prefix>
43eccc7665SIngo Weinhold                              Assume cross compilation. <prefix> should be a
44eccc7665SIngo Weinhold                              path to the directory where the cross
45eccc7665SIngo Weinhold                              compilation tools are located, plus the platform
460da9c208SIngo Weinhold                              prefix, e.g. "/path/to/tools/i586-pc-haiku-".
47eccc7665SIngo Weinhold                              This overrides the HAIKU_* tool variables.
48a66c32ddSIngo Weinhold  --distro-compatibility <level>
49a66c32ddSIngo Weinhold                              The distribution's level of compatibility with
50a66c32ddSIngo Weinhold                              the official Haiku distribution. The generated
51a66c32ddSIngo Weinhold                              files will contain the respective trademarks
52a66c32ddSIngo Weinhold                              accordingly.
53a66c32ddSIngo Weinhold                              official -- the official Haiku distribution.
54a66c32ddSIngo Weinhold                              compatible -- a Haiku Compatible (tm) distro.
55a66c32ddSIngo Weinhold                              default -- any other distro (default value).
5660d8d8fcSIngo Weinhold  --enable-multiuser          Enable experimental multiuser support.
57eccc7665SIngo Weinhold  --help                      Prints out this help.
58eccc7665SIngo Weinhold  --include-gpl-addons        Include GPL licensed add-ons.
5967838392SAxel Dörfler  --include-patented-code     Enable code that is known to implemented patented
6067838392SAxel Dörfler                              ideas and techniques. If this option is not
6167838392SAxel Dörfler                              specified, the resulting distribution may still
6267838392SAxel Dörfler                              implement patented ideas and techniques. This
6367838392SAxel Dörfler                              option only disables code that is currently known
6467838392SAxel Dörfler                              to be problematic.
6576fa0be3SIngo Weinhold  --include-sources           Includes the source code of projects that require
6676fa0be3SIngo Weinhold                              either an offer of source code or a copy of the
6776fa0be3SIngo Weinhold                              patched sources. This is preferable when
6876fa0be3SIngo Weinhold                              distributing on physical mediums.
691974210fSFrançois Revol  --include-3rdparty          Include 3rdparty/ in the build system.
7060d8d8fcSIngo Weinhold  -j<n>                       Only relevant for --build-cross-tools and
7160d8d8fcSIngo Weinhold                              --build-cross-tools-gcc4. Is passed on to the
7260d8d8fcSIngo Weinhold                              make building the build tools.
737c4641d0SOliver Tappe  --target=TARGET             Select build target platform.
747c4641d0SOliver Tappe                              [default=${TARGET_PLATFORM}]
75a17b9c0cSshatty                              valid targets=r5,bone,dano,haiku
767c4641d0SOliver Tappe  --update                    re-runs last configure invocation [must be given
777c4641d0SOliver Tappe                              as first option!]
78eccc7665SIngo Weinhold  --use-gcc-pipe              Build with GCC option -pipe. Speeds up the build
795a34a443SFrançois Revol                              process, but uses more memory.
800385b065SIngo Weinhold  --use-32bit                 Use -m32 flag on 64bit host gcc compiler.
814f4e5272SIngo Weinhold  --use-xattr                 Use Linux xattr support for BeOS attribute
824f4e5272SIngo Weinhold                              emulation. Warning: Make sure your file system
834f4e5272SIngo Weinhold                              supports sufficient attribute sizes (4 KB per
844f4e5272SIngo Weinhold                              file for all attributes won't suffice).
85338b8dc3SIngo Weinhold
86338b8dc3SIngo Weinholdenvironment variables:
87338b8dc3SIngo Weinhold  HAIKU_AR                    The static library archiver. Defaults to "ar".
88338b8dc3SIngo Weinhold  HAIKU_CC                    The compiler. Defaults to "gcc".
89338b8dc3SIngo Weinhold  HAIKU_LD                    The linker. Defaults to "ld".
90338b8dc3SIngo Weinhold  HAIKU_OBJCOPY               The objcopy to be used. Defaults to "objcopy".
91338b8dc3SIngo Weinhold  HAIKU_RANLIB                The static library indexer. Defaults to "ranlib".
9277e84f21SIngo Weinhold  HAIKU_YASM                  The yasm assembler (x86 only).
93338b8dc3SIngo Weinhold  HAIKU_CPPFLAGS              The preprocessor flags. Defaults to "".
94338b8dc3SIngo Weinhold  HAIKU_CCFLAGS               The C flags. Defaults to "".
95338b8dc3SIngo Weinhold  HAIKU_CXXFLAGS              The C++ flags. Defaults to "".
96338b8dc3SIngo Weinhold  HAIKU_LDFLAGS               The linker flags. Defaults to "".
97338b8dc3SIngo Weinhold  HAIKU_ARFLAGS               The flags passed to HAIKU_AR for archiving.
9823eb9a9eSFrançois Revol                              Defaults to "cru".
99338b8dc3SIngo Weinhold  HAIKU_UNARFLAGS             The flags passed to HAIKU_AR for unarchiving.
100338b8dc3SIngo Weinhold                              Defaults to "x".
10164f6da31SIngo Weinhold
10264f6da31SIngo WeinholdNon-standard output directories:
10364f6da31SIngo Weinhold  By default all objects, build configuration, and other related files are
10464f6da31SIngo Weinhold  stored in /path/to/haiku_source/generated.  To store objects in a non-default
10564f6da31SIngo Weinhold  location, run "../../relative/path/to/haiku_source/configure <options>" from
10664f6da31SIngo Weinhold  within your non-default location.  "jam [ options ] targets" can then be run
10764f6da31SIngo Weinhold  directly inside your non-default location.  Another option is to invoke "jam
10864f6da31SIngo Weinhold  [ options ] targets" from within haiku_source.  This can be accomplished by
10964f6da31SIngo Weinhold  either "export HAIKU_OUTPUT_DIR=your non-default location" before invoking
11064f6da31SIngo Weinhold  jam or by creating a symlink of haiku_source/generated pointing to your
11164f6da31SIngo Weinhold  non-default location and running jam.
11264f6da31SIngo Weinhold
11364f6da31SIngo Weinhold
114022fa244SIngo WeinholdEOF
115022fa244SIngo Weinhold}
116022fa244SIngo Weinhold
117022fa244SIngo Weinhold# assertparam
118022fa244SIngo Weinhold#
119022fa244SIngo Weinhold# Checks whether at least one parameter is left.
120022fa244SIngo Weinhold#
121022fa244SIngo Weinholdassertparam()
122022fa244SIngo Weinhold{
12320ab75e6SIngo Weinhold	if [ $2 -lt 2 ]; then
124022fa244SIngo Weinhold		echo $0: \`$1\': Parameter expected.
125022fa244SIngo Weinhold		exit 1
126022fa244SIngo Weinhold	fi
127022fa244SIngo Weinhold}
128022fa244SIngo Weinhold
12920ab75e6SIngo Weinhold# assertparams
13020ab75e6SIngo Weinhold#
13120ab75e6SIngo Weinhold# Checks whether at least a certain number of parameters is left.
13220ab75e6SIngo Weinhold#
13320ab75e6SIngo Weinholdassertparams()
13420ab75e6SIngo Weinhold{
13520ab75e6SIngo Weinhold	if [ $3 -le $2 ]; then
13620ab75e6SIngo Weinhold		echo $0: \`$1\': Not enough parameters.
13720ab75e6SIngo Weinhold		exit 1
13820ab75e6SIngo Weinhold	fi
13920ab75e6SIngo Weinhold}
14020ab75e6SIngo Weinhold
14109c5682dSIngo Weinhold# standard_gcc_settings
14209c5682dSIngo Weinhold#
14309c5682dSIngo Weinhold# Sets the variables for a GCC platform.
14409c5682dSIngo Weinhold#
14509c5682dSIngo Weinholdstandard_gcc_settings()
14609c5682dSIngo Weinhold{
147*138f5fb4SIngo Weinhold	if which greadlink > /dev/null 2>&1; then
148b29b48b1SMatt Madia		readlink="greadlink -e"
149*138f5fb4SIngo Weinhold	elif which realpath > /dev/null 2>&1; then
150b29b48b1SMatt Madia		readlink=realpath
151b4b6d83cSMatt Madia	else
152b29b48b1SMatt Madia		readlink="readlink -e"
153b4b6d83cSMatt Madia	fi
154*138f5fb4SIngo Weinhold
15509c5682dSIngo Weinhold	# PLATFORM_LINKLIBS
156338b8dc3SIngo Weinhold	gcclib=`$HAIKU_CC -print-libgcc-file-name`
15709c5682dSIngo Weinhold	gccdir=`dirname ${gcclib}`
1585b0f7b1bSOliver Tappe
1597c4641d0SOliver Tappe	HAIKU_GCC_RAW_VERSION=`$HAIKU_CC -dumpversion`
1607c4641d0SOliver Tappe	HAIKU_GCC_MACHINE=`$HAIKU_CC -dumpmachine`
161338b8dc3SIngo Weinhold
162338b8dc3SIngo Weinhold	HAIKU_GCC_LIB_DIR=${gccdir}
163338b8dc3SIngo Weinhold	HAIKU_GCC_LIBGCC=${gccdir}/libgcc.a
164338b8dc3SIngo Weinhold	HAIKU_GCC_GLUE_CODE="crtbegin.o crtend.o"
16528b5bc75SMichael Lotz	HAIKU_GCC_HEADERS_DIR="${gccdir}/include
16628b5bc75SMichael Lotz		${gccdir}/include-fixed"
1675d978968SIngo Weinhold	HAIKU_GCC_LIBGCC_OBJECTS=`$HAIKU_AR t ${HAIKU_GCC_LIBGCC} | grep -v eabi.o`
1685d978968SIngo Weinhold		# Note: We filter out eabi.o. It's present in gcc's libgcc for PPC and
1695d978968SIngo Weinhold		# neither needed nor wanted.
1708b5934c9SIngo Weinhold
1717c4641d0SOliver Tappe	case $HAIKU_GCC_RAW_VERSION in
1728b5934c9SIngo Weinhold		4.*)
1735b0f7b1bSOliver Tappe			# for gcc 4 we use the libstdc++ and libsupc++ that come with the
1745b0f7b1bSOliver Tappe			# compiler
1757c4641d0SOliver Tappe			HAIKU_STATIC_LIBSTDCXX=`$HAIKU_CC -print-file-name=libstdc++.a`
1767c4641d0SOliver Tappe			HAIKU_SHARED_LIBSTDCXX=`$HAIKU_CC -print-file-name=libstdc++.so`
1777c4641d0SOliver Tappe			HAIKU_STATIC_LIBSUPCXX=`$HAIKU_CC -print-file-name=libsupc++.a`
1787c4641d0SOliver Tappe			HAIKU_SHARED_LIBSUPCXX=`$HAIKU_CC -print-file-name=libsupc++.so`
17914210488SMichael Lotz
18014210488SMichael Lotz			local headers
1817c4641d0SOliver Tappe			if [ -d $gccdir/../../../../$HAIKU_GCC_MACHINE/include/c++/$HAIKU_GCC_RAW_VERSION ]; then
1827c4641d0SOliver Tappe				headers=$gccdir/../../../../$HAIKU_GCC_MACHINE/include/c++/$HAIKU_GCC_RAW_VERSION
18314210488SMichael Lotz			else
1847c4641d0SOliver Tappe				headers=$gccdir/../../../../include/c++/$HAIKU_GCC_RAW_VERSION
18514210488SMichael Lotz			fi
18614210488SMichael Lotz
1877c4641d0SOliver Tappe			HAIKU_CXX_HEADERS_DIR=$headers
1887c4641d0SOliver Tappe			for d in $HAIKU_GCC_MACHINE backward ext; do
18929ef597dSIngo Weinhold				# Note: We need the line break, otherwise the line might become
19029ef597dSIngo Weinhold				# too long for jam (512 bytes max).
1917c4641d0SOliver Tappe				HAIKU_CXX_HEADERS_DIR="$HAIKU_CXX_HEADERS_DIR
19229ef597dSIngo Weinhold					$headers/$d"
1938b5934c9SIngo Weinhold			done
194274b450aSMarcus Overhagen
1953f9f9f9aSIngo Weinhold			# Unset the HAIKU_{SHARED,STATIC}_LIB{STD,SUP}CXX variables, if the
1963f9f9f9aSIngo Weinhold			# compiler didn't give us actual file names. Otherwise resolve
1973f9f9f9aSIngo Weinhold			# symlinks to avoid problems when copying the libraries to the
1983f9f9f9aSIngo Weinhold			# image.
1998b5934c9SIngo Weinhold
2007c4641d0SOliver Tappe			if [ $HAIKU_STATIC_LIBSTDCXX = libstdc++.a ]; then
2017c4641d0SOliver Tappe				HAIKU_STATIC_LIBSTDCXX=
2023f9f9f9aSIngo Weinhold			else
203b29b48b1SMatt Madia				HAIKU_STATIC_LIBSTDCXX=`$readlink $HAIKU_STATIC_LIBSTDCXX`
2048b5934c9SIngo Weinhold			fi
2053f9f9f9aSIngo Weinhold
206ffe8b20cSIngo Weinhold			if [ $HAIKU_SHARED_LIBSTDCXX = libstdc++.so ]; then
207ffe8b20cSIngo Weinhold				HAIKU_SHARED_LIBSTDCXX=
2083f9f9f9aSIngo Weinhold			else
209b29b48b1SMatt Madia				HAIKU_SHARED_LIBSTDCXX=`$readlink $HAIKU_SHARED_LIBSTDCXX`
210ffe8b20cSIngo Weinhold			fi
2113f9f9f9aSIngo Weinhold
2127c4641d0SOliver Tappe			if [ $HAIKU_STATIC_LIBSUPCXX = libsupc++.a ]; then
2137c4641d0SOliver Tappe				HAIKU_STATIC_LIBSUPCXX=
2143f9f9f9aSIngo Weinhold			else
215b29b48b1SMatt Madia				HAIKU_STATIC_LIBSUPCXX=`$readlink $HAIKU_STATIC_LIBSUPCXX`
216c89fc875SIngo Weinhold			fi
2173f9f9f9aSIngo Weinhold
218ffe8b20cSIngo Weinhold			if [ $HAIKU_SHARED_LIBSUPCXX = libsupc++.so ]; then
219ffe8b20cSIngo Weinhold				HAIKU_SHARED_LIBSUPCXX=
2203f9f9f9aSIngo Weinhold			else
221b29b48b1SMatt Madia				HAIKU_SHARED_LIBSUPCXX=`$readlink $HAIKU_SHARED_LIBSUPCXX`
222ffe8b20cSIngo Weinhold			fi
2238b5934c9SIngo Weinhold		;;
2246cc8eecfSOliver Tappe		2.9*)
2255b0f7b1bSOliver Tappe			# check for correct (most up-to-date) legacy compiler and complain
2265b0f7b1bSOliver Tappe			# if an older one is installed
2277c4641d0SOliver Tappe			if [ $HAIKU_GCC_RAW_VERSION != $haikuRequiredLegacyGCCVersion ]; then
2285b0f7b1bSOliver Tappe				echo "GCC version $haikuRequiredLegacyGCCVersion is required!";
2295b0f7b1bSOliver Tappe				echo "Please download it from www.haiku-os.org...";
2305b0f7b1bSOliver Tappe				exit 1;
2315b0f7b1bSOliver Tappe			fi
2325b0f7b1bSOliver Tappe		;;
2338b5934c9SIngo Weinhold	esac
23409c5682dSIngo Weinhold}
23509c5682dSIngo Weinhold
236338b8dc3SIngo Weinhold# set_default_value
237338b8dc3SIngo Weinhold#
238338b8dc3SIngo Weinhold# Set the value for a variable, if no value is set yet.
239338b8dc3SIngo Weinhold#
240338b8dc3SIngo Weinholdset_default_value()
241338b8dc3SIngo Weinhold{
2420838a930SJérôme Duval	eval "$1=\${$1-$2}"
243338b8dc3SIngo Weinhold}
244338b8dc3SIngo Weinhold
245338b8dc3SIngo Weinhold# get_build_tool_path
246338b8dc3SIngo Weinhold#
247338b8dc3SIngo Weinhold# Gets a usable absolute path of a build tool.
248338b8dc3SIngo Weinhold#
249338b8dc3SIngo Weinholdget_build_tool_path()
250338b8dc3SIngo Weinhold{
251338b8dc3SIngo Weinhold	local var="HAIKU_$1"
252338b8dc3SIngo Weinhold	local tool=$2
253338b8dc3SIngo Weinhold	local path="${crossToolsPrefix}$tool"
254338b8dc3SIngo Weinhold
255338b8dc3SIngo Weinhold	if [ -f "$path" ]; then
256338b8dc3SIngo Weinhold		# get absolute path
257a559f87aSFrançois Revol		local oldPwd="`pwd`"
258a559f87aSFrançois Revol		cd "`dirname "$path"`"
259a559f87aSFrançois Revol		path="`pwd`/`basename "$path"`"
260338b8dc3SIngo Weinhold		cd $oldPwd
261338b8dc3SIngo Weinhold	else
2627fe2e06cSMatt Madia		which "$path" > /dev/null 2>&1 || {
263338b8dc3SIngo Weinhold			echo "Build tool \"$path\" not found." >&2
264338b8dc3SIngo Weinhold			exit 1
265338b8dc3SIngo Weinhold		}
266338b8dc3SIngo Weinhold	fi
267338b8dc3SIngo Weinhold
268338b8dc3SIngo Weinhold	eval "$var=$path"
269338b8dc3SIngo Weinhold}
270338b8dc3SIngo Weinhold
271338b8dc3SIngo Weinhold# get cwd and the source directory
272338b8dc3SIngo WeinholdcurrentDir=`pwd`
2736e7c6fe5SIngo Weinholdcd `dirname "$0"`
274338b8dc3SIngo WeinholdsourceDir=`pwd`
2756e7c6fe5SIngo Weinholdcd "$currentDir"
276338b8dc3SIngo Weinhold
27755d267a4SFrançois Revol# backup the passed arguments
27855d267a4SFrançois RevolconfigureArgs="$@"
27955d267a4SFrançois Revol
2807c4641d0SOliver Tappe# internal default parameter values
281022fa244SIngo Weinhold#
28252a38012Sejakowatzplatform=`uname`
2835abd9a46SIngo WeinholdplatformMachine=`uname  -m`
28477e84f21SIngo WeinholdtargetArch=x86
285338b8dc3SIngo WeinholdcrossToolsPrefix=
286338b8dc3SIngo WeinholdbuildCrossTools=
28729ef597dSIngo WeinholdbuildCrossToolsScript="$sourceDir/build/scripts/build_cross_tools"
28820ab75e6SIngo WeinholdbuildCrossToolsMachine=
28960d8d8fcSIngo WeinholdbuildCrossToolsJobs=
2907c4641d0SOliver Tappe
2917c4641d0SOliver Tappe# exported (BuildSetup) default parameter values
2927c4641d0SOliver Tappe#
2937c4641d0SOliver TappeHAIKU_GCC_RAW_VERSION=
2947c4641d0SOliver TappeHAIKU_GCC_MACHINE=i586-pc-haiku
2957c4641d0SOliver TappeHAIKU_STATIC_LIBSTDCXX=
2967c4641d0SOliver TappeHAIKU_SHARED_LIBSTDCXX=
2977c4641d0SOliver TappeHAIKU_STATIC_LIBSUPCXX=
2987c4641d0SOliver TappeHAIKU_SHARED_LIBSUPCXX=
2997c4641d0SOliver TappeHAIKU_CXX_HEADERS_DIR=
3007c4641d0SOliver TappeHOST_GCC_RAW_VERSION=`gcc -dumpversion`
3017c4641d0SOliver TappeHOST_GCC_MACHINE=`gcc -dumpmachine`
3027c4641d0SOliver TappeHAIKU_INCLUDE_GPL_ADDONS=0
3037c4641d0SOliver TappeHAIKU_INCLUDE_PATENTED_CODE=0
30476fa0be3SIngo WeinholdHAIKU_INCLUDE_SOURCES=0
3057c4641d0SOliver TappeHAIKU_INCLUDE_3RDPARTY=0
3067c4641d0SOliver TappeHAIKU_ENABLE_MULTIUSER=0
3077c4641d0SOliver TappeHAIKU_DISTRO_COMPATIBILITY=default
3087c4641d0SOliver TappeTARGET_PLATFORM=haiku
3097c4641d0SOliver TappeHAIKU_USE_GCC_PIPE=0
3107986925fSIngo WeinholdHAIKU_HOST_USE_32BIT=0
3117986925fSIngo WeinholdHAIKU_HOST_USE_XATTR=0
3127c4641d0SOliver TappeHAIKU_ALTERNATIVE_GCC_OUTPUT_DIR=
3137c4641d0SOliver TappeHAIKU_ADD_ALTERNATIVE_GCC_LIBS=
3147c4641d0SOliver TappeHOST_GCC_LD=`gcc -print-prog-name=ld`
3157c4641d0SOliver TappeHOST_GCC_OBJCOPY=`gcc -print-prog-name=objcopy`
316c505b276SFrançois RevolSFDISK_BINARY=sfdisk
317c505b276SFrançois RevolHOST_SFDISK=$SFDISK_BINARY
318338b8dc3SIngo Weinhold
319089cfbf7SIngo WeinholdhaikuRequiredLegacyGCCVersion="2.95.3-haiku-100420"
320a559f87aSFrançois Revolexport haikuRequiredLegacyGCCVersion
321af4bf973SOliver Tappe	# version of legacy gcc required to build haiku
322af4bf973SOliver Tappe
323338b8dc3SIngo Weinholdset_default_value HAIKU_AR			ar
324338b8dc3SIngo Weinholdset_default_value HAIKU_CC			gcc
325338b8dc3SIngo Weinholdset_default_value HAIKU_LD			ld
326338b8dc3SIngo Weinholdset_default_value HAIKU_OBJCOPY		objcopy
327338b8dc3SIngo Weinholdset_default_value HAIKU_RANLIB		ranlib
32877e84f21SIngo Weinholdset_default_value HAIKU_YASM		yasm
329338b8dc3SIngo Weinholdset_default_value HAIKU_CPPFLAGS	""
330338b8dc3SIngo Weinholdset_default_value HAIKU_CCFLAGS		""
331338b8dc3SIngo Weinholdset_default_value HAIKU_CXXFLAGS	""
332338b8dc3SIngo Weinholdset_default_value HAIKU_LDFLAGS		""
33323eb9a9eSFrançois Revolset_default_value HAIKU_ARFLAGS		cru
334338b8dc3SIngo Weinholdset_default_value HAIKU_UNARFLAGS	x
33562339647SAxel Dörfler
3367c4641d0SOliver Tappe# determine output directory
3377c4641d0SOliver Tappeif [ "$currentDir" = "$sourceDir" ]; then
3387c4641d0SOliver Tappe	outputDir=$currentDir/generated
3397c4641d0SOliver Tappeelse
3407c4641d0SOliver Tappe	outputDir=$currentDir
3417c4641d0SOliver Tappefi
3427c4641d0SOliver TappebuildOutputDir="$outputDir/build"
3437c4641d0SOliver TappeHAIKU_BUILD_ATTRIBUTES_DIR="$outputDir/attributes"
3447c4641d0SOliver TappebuildConfigFile="$buildOutputDir/BuildConfig"
3457c4641d0SOliver Tappe
3467c4641d0SOliver Tappe# check for update request
3477c4641d0SOliver Tappeif [ "$1" = "--update" ]; then
3487c4641d0SOliver Tappe	if ! [ -e "$buildConfigFile" ]; then
3497c4641d0SOliver Tappe		echo $0 --update: \'$buildConfigFile\' not found - updating not possible.
3507c4641d0SOliver Tappe		exit 1
3517c4641d0SOliver Tappe	fi
3527c4641d0SOliver Tappe	if ! type perl >/dev/null 2>&1; then
3537c4641d0SOliver Tappe		echo $0 --update: \'perl\' not found - updating not possible.
3547c4641d0SOliver Tappe		exit 1
3557c4641d0SOliver Tappe	fi
3567c4641d0SOliver Tappe	# convert BuildConfig from jam format to shell format and evaluate it
3577c4641d0SOliver Tappe	shellConfigFile="${buildConfigFile}.shell"
3587c4641d0SOliver Tappe	perl "$sourceDir/build/scripts/convert_build_config_to_shell_format.pl" \
3597c4641d0SOliver Tappe		<"$buildConfigFile" >"$shellConfigFile"
3607c4641d0SOliver Tappe	. "$shellConfigFile"
3617c4641d0SOliver Tappe	rm "$shellConfigFile"
3627c4641d0SOliver Tappe	shift
3637c4641d0SOliver Tappefi
3647c4641d0SOliver Tappe
365022fa244SIngo Weinhold# parse parameters
366022fa244SIngo Weinhold#
36720ab75e6SIngo Weinholdwhile [ $# -gt 0 ] ; do
368022fa244SIngo Weinhold	case "$1" in
36960d8d8fcSIngo Weinhold		--alternative-gcc-output-dir)
37060d8d8fcSIngo Weinhold			assertparam "$1" $#
37160d8d8fcSIngo Weinhold			cd $2 || exit 1
3727c4641d0SOliver Tappe			HAIKU_ALTERNATIVE_GCC_OUTPUT_DIR=`pwd`
3737c4641d0SOliver Tappe			HAIKU_ADD_ALTERNATIVE_GCC_LIBS=1
37460d8d8fcSIngo Weinhold			cd $currentDir
37560d8d8fcSIngo Weinhold			shift 2
37660d8d8fcSIngo Weinhold			;;
377a5b60fa8SOliver Tappe		--build-cross-tools) assertparam "$1" $#; buildCrossTools=$2; shift 2;;
3789b0dd528SIngo Weinhold		--build-cross-tools-gcc4)
3799b0dd528SIngo Weinhold			assertparams "$1" 2 $#
3809b0dd528SIngo Weinhold			buildCrossTools=$3
3819b0dd528SIngo Weinhold			buildCrossToolsScript="${buildCrossToolsScript}_gcc4"
38220ab75e6SIngo Weinhold			case "$2" in
3837c4641d0SOliver Tappe				x86)	HAIKU_GCC_MACHINE=i586-pc-haiku;;
3847c4641d0SOliver Tappe				ppc)	HAIKU_GCC_MACHINE=powerpc-apple-haiku; targetArch=ppc;;
3857c4641d0SOliver Tappe				m68k)	HAIKU_GCC_MACHINE=m68k-unknown-haiku; targetArch=m86k;;
3867c4641d0SOliver Tappe				arm)	HAIKU_GCC_MACHINE=arm-unknown-haiku; targetArch=arm;;
3877c4641d0SOliver Tappe				mipsel)	HAIKU_GCC_MACHINE=mipsel-unknown-haiku; targetArch=mips;;
38820ab75e6SIngo Weinhold				*)		echo "Unsupported target architecture: $2"
38920ab75e6SIngo Weinhold						exit 1;;
39020ab75e6SIngo Weinhold			esac
3917c4641d0SOliver Tappe			buildCrossToolsMachine=$HAIKU_GCC_MACHINE
3929b0dd528SIngo Weinhold			shift 3
3939b0dd528SIngo Weinhold			;;
3949b0dd528SIngo Weinhold		--cross-tools-prefix)
3959b0dd528SIngo Weinhold			assertparam "$1" $#
3969b0dd528SIngo Weinhold			crossToolsPrefix=$2
3979b0dd528SIngo Weinhold			shift 2
3989b0dd528SIngo Weinhold			;;
399a66c32ddSIngo Weinhold		--distro-compatibility)
4009b0dd528SIngo Weinhold			assertparam "$1" $#
4017c4641d0SOliver Tappe			HAIKU_DISTRO_COMPATIBILITY=$2
4027c4641d0SOliver Tappe			case "$HAIKU_DISTRO_COMPATIBILITY" in
403a66c32ddSIngo Weinhold				official)	;;
404a66c32ddSIngo Weinhold				compatible)	;;
405a66c32ddSIngo Weinhold				default)	;;
406a66c32ddSIngo Weinhold				*)			echo "Invalid distro compatibility" \
4077c4641d0SOliver Tappe								"level: $HAIKU_DISTRO_COMPATIBILITY"
408a66c32ddSIngo Weinhold							exit 1;;
409a66c32ddSIngo Weinhold			esac
4109b0dd528SIngo Weinhold			shift 2
4119b0dd528SIngo Weinhold			;;
4127c4641d0SOliver Tappe		--enable-multiuser)	HAIKU_ENABLE_MULTIUSER=1; shift 1;;
41360d8d8fcSIngo Weinhold		--help | -h)	usage; exit 0;;
4147c4641d0SOliver Tappe		--include-gpl-addons)	HAIKU_INCLUDE_GPL_ADDONS=1; shift 1;;
4157c4641d0SOliver Tappe		--include-patented-code)	HAIKU_INCLUDE_PATENTED_CODE=1; shift 1;;
41676fa0be3SIngo Weinhold		--include-sources)	HAIKU_INCLUDE_SOURCES=1; shift 1;;
4177c4641d0SOliver Tappe		--include-3rdparty)	HAIKU_INCLUDE_3RDPARTY=1; shift 1;;
41860d8d8fcSIngo Weinhold        -j*)				buildCrossToolsJobs="$1"; shift 1;;
4197c4641d0SOliver Tappe		--target=*)     TARGET_PLATFORM=`echo $1 | cut -d'=' -f2-`; shift 1;;
4207c4641d0SOliver Tappe		--use-gcc-pipe)	HAIKU_USE_GCC_PIPE=1; shift 1;;
4217986925fSIngo Weinhold		--use-32bit)	HAIKU_HOST_USE_32BIT=1; shift 1;;
4227986925fSIngo Weinhold		--use-xattr)	HAIKU_HOST_USE_XATTR=1; shift 1;;
423022fa244SIngo Weinhold		*)				echo Invalid argument: \`$1\'; exit 1;;
424022fa244SIngo Weinhold	esac
425022fa244SIngo Weinholddone
426022fa244SIngo Weinhold
4270df3cc9cSIngo Weinhold# detect the build platform
428338b8dc3SIngo Weinholdcase "${platform}" in
4290df3cc9cSIngo Weinhold	BeOS)	revision=`uname -r`
4300df3cc9cSIngo Weinhold			case "$revision" in
4317c4641d0SOliver Tappe				6.*)	HOST_PLATFORM=dano ;;
4327c4641d0SOliver Tappe				5.1)	HOST_PLATFORM=dano ;;
4337c4641d0SOliver Tappe				5.0.4)	HOST_PLATFORM=bone ;;
4347c4641d0SOliver Tappe				5.0*)	HOST_PLATFORM=r5 ;;
4350df3cc9cSIngo Weinhold				*)		echo Unknown BeOS version: $revision
4360df3cc9cSIngo Weinhold						exit 1 ;;
4370df3cc9cSIngo Weinhold			esac
4380df3cc9cSIngo Weinhold			;;
4397c4641d0SOliver Tappe	Darwin)	HOST_PLATFORM=darwin ;;
4407c4641d0SOliver Tappe	FreeBSD)	HOST_PLATFORM=freebsd
441c505b276SFrançois Revol				SFDISK_BINARY=sfdisk-linux
4427986925fSIngo Weinhold				if [ "$HAIKU_HOST_USE_32BIT" = 1 ] ; then
4435abd9a46SIngo Weinhold					echo Unsupported platform: FreeBSD ${platformMachine}
444308c212cSIngo Weinhold					exit 1
445308c212cSIngo Weinhold				fi	;;
4467c4641d0SOliver Tappe	Haiku)	HOST_PLATFORM=haiku_host ;;
4477c4641d0SOliver Tappe	Linux)	HOST_PLATFORM=linux ;;
4487c4641d0SOliver Tappe	OpenBSD) HOST_PLATFORM=openbsd ;;
4497c4641d0SOliver Tappe	SunOS)	HOST_PLATFORM=sunos ;;
4507c4641d0SOliver Tappe	CYGWIN_NT-*) HOST_PLATFORM=cygwin ;;
451338b8dc3SIngo Weinhold	*)		echo Unsupported platform: ${platform}
4524cbe4925SAxel Dörfler			exit 1 ;;
4534cbe4925SAxel Dörfleresac
45452a38012Sejakowatz
45577e84f21SIngo Weinhold# check yasm version
45677e84f21SIngo Weinholdif [ $targetArch = "x86" ]; then
45777e84f21SIngo Weinhold	$HAIKU_YASM --version > /dev/null || {
45892696166SIngo Weinhold		echo "The yasm assembler version 0.7.0 or later must be installed."
45977e84f21SIngo Weinhold		echo "Download from: http://www.tortall.net/projects/yasm/wiki/Download"
46077e84f21SIngo Weinhold		exit 1
46177e84f21SIngo Weinhold	}
46277e84f21SIngo Weinhold
46377e84f21SIngo Weinhold	set -- $($HAIKU_YASM --version | head -n 1)
46477e84f21SIngo Weinhold	versionOK=0
46577e84f21SIngo Weinhold	case $2 in
46692696166SIngo Weinhold		0.[0-6].*)		;;
46777e84f21SIngo Weinhold		*)				versionOK=1 ;;
46877e84f21SIngo Weinhold	esac
46977e84f21SIngo Weinhold
47077e84f21SIngo Weinhold	if [ $versionOK = 0 ]; then
47192696166SIngo Weinhold		echo "The yasm assembler version 0.7.0 or later must be installed."
47277e84f21SIngo Weinhold		echo "The installed version is $2."
47377e84f21SIngo Weinhold		echo "Download from: http://www.tortall.net/projects/yasm/wiki/Download"
47477e84f21SIngo Weinhold		exit 1
47577e84f21SIngo Weinhold	fi
47677e84f21SIngo Weinholdfi
47777e84f21SIngo Weinhold
478c505b276SFrançois Revol# check common locations for sfdisk
479c505b276SFrançois Revolfor sfdiskDir in /sbin /usr/sbin /usr/local/sbin ; do
480c505b276SFrançois Revol	if [ -e ${sfdiskDir}/${SFDISK_BINARY} ]; then
481c505b276SFrançois Revol		HOST_SFDISK=${sfdiskDir}/${SFDISK_BINARY}
482c505b276SFrançois Revol	fi
483c505b276SFrançois Revoldone
484c505b276SFrançois Revol
4853ecc5287SMichael Lotz# check for case-sensitive filesystem if on darwin
4867c4641d0SOliver Tappeif [ $HOST_PLATFORM = "darwin" ]; then
4870651c859SMichael Pfeiffer	diskutil info $(pwd) | grep -i "case-sensitive" > /dev/null
4883ecc5287SMichael Lotz	if [ $? != 0 ]; then
4893ecc5287SMichael Lotz		echo "You need a case-sensitive file-system to build Haiku."
4903ecc5287SMichael Lotz		echo "Please see the following guide on how to set one up:"
4913ecc5287SMichael Lotz		echo "http://haiku-os.org/documents/dev/how_to_build_haiku_on_mac_os_x"
4923ecc5287SMichael Lotz		exit 1
4933ecc5287SMichael Lotz	fi
4943ecc5287SMichael Lotzfi
4953ecc5287SMichael Lotz
496338b8dc3SIngo Weinhold# create output directory
4976e7c6fe5SIngo Weinholdmkdir -p "$buildOutputDir" || exit 1
498338b8dc3SIngo Weinhold
499338b8dc3SIngo Weinhold# build cross tools from sources
500338b8dc3SIngo Weinholdif [ -n "$buildCrossTools" ]; then
50120ab75e6SIngo Weinhold	"$buildCrossToolsScript" $buildCrossToolsMachine "$sourceDir" \
50260d8d8fcSIngo Weinhold		"$buildCrossTools" "$outputDir" $buildCrossToolsJobs || exit 1
5037c4641d0SOliver Tappe	crossToolsPrefix="$outputDir/cross-tools/bin/${HAIKU_GCC_MACHINE}-"
504338b8dc3SIngo Weinholdfi
505338b8dc3SIngo Weinhold
506338b8dc3SIngo Weinhold# cross tools
507338b8dc3SIngo Weinholdif [ -n "$crossToolsPrefix" ]; then
508338b8dc3SIngo Weinhold	get_build_tool_path AR ar
509338b8dc3SIngo Weinhold	get_build_tool_path CC gcc
510338b8dc3SIngo Weinhold	get_build_tool_path LD ld
511338b8dc3SIngo Weinhold	get_build_tool_path OBJCOPY objcopy
512338b8dc3SIngo Weinhold	get_build_tool_path RANLIB ranlib
513338b8dc3SIngo Weinholdfi
514338b8dc3SIngo Weinhold
515338b8dc3SIngo Weinhold# prepare gcc settings
516338b8dc3SIngo Weinholdstandard_gcc_settings
517338b8dc3SIngo Weinhold
518eedc3d0bSIngo Weinhold# check whether the Haiku compiler really targets Haiku or BeOS
5197c4641d0SOliver Tappecase "$HAIKU_GCC_MACHINE" in
520eedc3d0bSIngo Weinhold	*-*-haiku)	;;
521eedc3d0bSIngo Weinhold	*-*-beos)	;;
522eedc3d0bSIngo Weinhold	*) echo The compiler specified as Haiku target compiler is not a valid \
523eedc3d0bSIngo Weinhold			Haiku cross-compiler. Please see ReadMe.cross-compile. >&2
524eedc3d0bSIngo Weinhold	   echo compiler: $HAIKU_CC
5257c4641d0SOliver Tappe	   echo compiler is configured for target: $HAIKU_GCC_MACHINE
526eedc3d0bSIngo Weinhold	   exit 1 ;;
527eedc3d0bSIngo Weinholdesac
528eedc3d0bSIngo Weinhold
52952a38012Sejakowatz# Generate BuildConfig
5307c4641d0SOliver Tappecat << EOF > "$buildConfigFile"
53152a38012Sejakowatz# BuildConfig
532ab2540c4SIngo Weinhold# Note: This file has been automatically generated by configure with the
533ab2540c4SIngo Weinhold# following arguments:
53455d267a4SFrançois Revol# ${configureArgs}
53552a38012Sejakowatz
5367c4641d0SOliver TappeTARGET_PLATFORM 			?= "${TARGET_PLATFORM}" ;
5377c4641d0SOliver TappeHOST_PLATFORM				?= "${HOST_PLATFORM}" ;
538338b8dc3SIngo Weinhold
5397c4641d0SOliver TappeHAIKU_INCLUDE_GPL_ADDONS			?= "${HAIKU_INCLUDE_GPL_ADDONS}" ;
5407c4641d0SOliver TappeHAIKU_INCLUDE_PATENTED_CODE			?= "${HAIKU_INCLUDE_PATENTED_CODE}" ;
54176fa0be3SIngo WeinholdHAIKU_INCLUDE_SOURCES				?= "${HAIKU_INCLUDE_SOURCES}" ;
5427c4641d0SOliver TappeHAIKU_INCLUDE_3RDPARTY				?= "${HAIKU_INCLUDE_3RDPARTY}" ;
5437c4641d0SOliver TappeHAIKU_ENABLE_MULTIUSER				?= "${HAIKU_ENABLE_MULTIUSER}" ;
5447c4641d0SOliver TappeHAIKU_DISTRO_COMPATIBILITY			?= "${HAIKU_DISTRO_COMPATIBILITY}" ;
5457c4641d0SOliver TappeHAIKU_USE_GCC_PIPE					?= "${HAIKU_USE_GCC_PIPE}" ;
5467986925fSIngo WeinholdHAIKU_HOST_USE_32BIT				?= "${HAIKU_HOST_USE_32BIT}" ;
5477986925fSIngo WeinholdHAIKU_HOST_USE_XATTR				?= "${HAIKU_HOST_USE_XATTR}" ;
5487c4641d0SOliver TappeHAIKU_ALTERNATIVE_GCC_OUTPUT_DIR	?= ${HAIKU_ALTERNATIVE_GCC_OUTPUT_DIR} ;
5497c4641d0SOliver TappeHAIKU_ADD_ALTERNATIVE_GCC_LIBS		?= ${HAIKU_ADD_ALTERNATIVE_GCC_LIBS} ;
550eccc7665SIngo Weinhold
5517c4641d0SOliver TappeHAIKU_GCC_RAW_VERSION		?= ${HAIKU_GCC_RAW_VERSION} ;
5527c4641d0SOliver TappeHAIKU_GCC_MACHINE			?= ${HAIKU_GCC_MACHINE} ;
553338b8dc3SIngo WeinholdHAIKU_GCC_LIB_DIR			?= ${HAIKU_GCC_LIB_DIR} ;
554338b8dc3SIngo WeinholdHAIKU_GCC_HEADERS_DIR		?= ${HAIKU_GCC_HEADERS_DIR} ;
555338b8dc3SIngo WeinholdHAIKU_GCC_LIBGCC			?= ${HAIKU_GCC_LIBGCC} ;
556338b8dc3SIngo Weinhold
5577c4641d0SOliver TappeHAIKU_STATIC_LIBSTDC++		?= ${HAIKU_STATIC_LIBSTDCXX} ;
5587c4641d0SOliver TappeHAIKU_SHARED_LIBSTDC++		?= ${HAIKU_SHARED_LIBSTDCXX} ;
5597c4641d0SOliver TappeHAIKU_STATIC_LIBSUPC++		?= ${HAIKU_STATIC_LIBSUPCXX} ;
5607c4641d0SOliver TappeHAIKU_SHARED_LIBSUPC++		?= ${HAIKU_SHARED_LIBSUPCXX} ;
5617c4641d0SOliver TappeHAIKU_C++_HEADERS_DIR		?= ${HAIKU_CXX_HEADERS_DIR} ;
5628b5934c9SIngo Weinhold
5637c4641d0SOliver TappeHAIKU_BUILD_ATTRIBUTES_DIR	?= ${HAIKU_BUILD_ATTRIBUTES_DIR} ;
564338b8dc3SIngo Weinhold
565338b8dc3SIngo WeinholdHAIKU_AR					?= ${HAIKU_AR} ;
566338b8dc3SIngo WeinholdHAIKU_CC					?= ${HAIKU_CC} ;
567338b8dc3SIngo WeinholdHAIKU_LD					?= ${HAIKU_LD} ;
568338b8dc3SIngo WeinholdHAIKU_OBJCOPY				?= ${HAIKU_OBJCOPY} ;
569338b8dc3SIngo WeinholdHAIKU_RANLIB				?= ${HAIKU_RANLIB} ;
57077e84f21SIngo WeinholdHAIKU_YASM					?= ${HAIKU_YASM} ;
571338b8dc3SIngo WeinholdHAIKU_CPPFLAGS				?= ${HAIKU_CPPFLAGS} ;
572338b8dc3SIngo WeinholdHAIKU_CCFLAGS				?= ${HAIKU_CCFLAGS} ;
573338b8dc3SIngo WeinholdHAIKU_CXXFLAGS				?= ${HAIKU_CXXFLAGS} ;
574338b8dc3SIngo WeinholdHAIKU_LDFLAGS				?= ${HAIKU_LDFLAGS} ;
575338b8dc3SIngo WeinholdHAIKU_ARFLAGS				?= ${HAIKU_ARFLAGS} ;
576338b8dc3SIngo WeinholdHAIKU_UNARFLAGS				?= ${HAIKU_UNARFLAGS} ;
577338b8dc3SIngo Weinhold
5787c4641d0SOliver TappeHOST_GCC_RAW_VERSION		?= ${HOST_GCC_RAW_VERSION} ;
5797c4641d0SOliver TappeHOST_GCC_MACHINE			?= ${HOST_GCC_MACHINE} ;
5807c4641d0SOliver TappeHOST_LD						?= ${HOST_GCC_LD} ;
5817c4641d0SOliver TappeHOST_OBJCOPY				?= ${HOST_GCC_OBJCOPY} ;
582c505b276SFrançois RevolHOST_SFDISK					?= ${HOST_SFDISK} ;
5838b5934c9SIngo Weinhold
584c4786ea6SlilloEOF
585c4786ea6Slillo
586b1e5b60cSAxel Dörfler# Libgcc.a objects
587b1e5b60cSAxel Dörfler
5886e7c6fe5SIngo Weinholdcat << EOF > "$buildOutputDir/libgccObjects"
589b1e5b60cSAxel Dörfler# libgcc.a objects to be linked against libroot.so
590b1e5b60cSAxel Dörfler# Note: This file has been automatically generated by configure.
591b1e5b60cSAxel Dörfler
592338b8dc3SIngo WeinholdHAIKU_GCC_LIBGCC_OBJECTS	?= ${HAIKU_GCC_LIBGCC_OBJECTS} ;
593b1e5b60cSAxel DörflerEOF
594b1e5b60cSAxel Dörfler
5954c74bde8SJérôme Duval# Generate Timezones binaries bindings
5964c74bde8SJérôme Duval
597338b8dc3SIngo WeinholdtimezoneSources="africa antarctica asia australasia europe northamerica
598338b8dc3SIngo Weinhold	southamerica pacificnew etcetera factory backward"
599338b8dc3SIngo Weinhold
6006e7c6fe5SIngo Weinholdcat << EOF > "$buildOutputDir/Timezones"
601b1e5b60cSAxel Dörfler# Timezones used for the build
602b1e5b60cSAxel Dörfler# Note: This file has been automatically generated by configure.
603b1e5b60cSAxel Dörfler
604338b8dc3SIngo WeinholdHAIKU_TIME_ZONE_SOURCES = ${timezoneSources} ;
605338b8dc3SIngo Weinhold
606b1e5b60cSAxel DörflerEOF
607b1e5b60cSAxel Dörfler
608338b8dc3SIngo Weinholdfor source in ${timezoneSources}; do
6093578c56aSAxel Dörfler	f=$sourceDir/src/data/timezones/$source
6104c74bde8SJérôme Duval
6116e7c6fe5SIngo WeinholdTZOBJECTS=`gawk '/^Zone/ { print $2 } /^Link/ { print $3 } ' "$f" `
6124c74bde8SJérôme Duval
6136e7c6fe5SIngo Weinholdcat << EOF >> "$buildOutputDir/Timezones"
614338b8dc3SIngo WeinholdTZ_OBJECTS on <timezone-source>${source} ?= $TZOBJECTS ;
6154c74bde8SJérôme DuvalEOF
6164c74bde8SJérôme Duvaldone
617338b8dc3SIngo Weinhold
6189b0dd528SIngo Weinhold# Generate a boot strap Jamfile in the output directory.
619338b8dc3SIngo Weinhold
620338b8dc3SIngo Weinholdcat << EOF > $outputDir/Jamfile
621338b8dc3SIngo Weinhold# automatically generated Jamfile
622338b8dc3SIngo Weinhold
623338b8dc3SIngo WeinholdHAIKU_TOP			= ${sourceDir} ;
624338b8dc3SIngo WeinholdHAIKU_OUTPUT_DIR	= ${outputDir} ;
625338b8dc3SIngo Weinhold
626338b8dc3SIngo Weinholdinclude [ FDirName \$(HAIKU_TOP) Jamfile ] ;
627338b8dc3SIngo Weinhold
628338b8dc3SIngo WeinholdEOF
629